'ROLL REPLACEMENT by Sober Panda
'Contact: david@soberpanda.com
'For usage instructions, type "/roll help" in the chat window.
'Please report errors to david@soberpanda.com.


#register /r RollReplacement
#register /roll RollReplacement Roll Replacement by Sober Panda. Type "/roll help" to view help information.

Sub RollReplacement()
	On Error Resume Next

	cs = GetChatSession() 
	ci = cs.GetLastItem() 
	os = GetCurrentSession()
	pc = GetCurrentPlayer()

	RepVal = os.GetField("RepField")
	AddVal = os.GetField("AddField")
	AddUVal = os.GetField("AddUField")
	RRVal = os.GetField("RRField")
	DVal = os.GetField("DField")
	TVal = os.GetField("TField")

	If RepVal = "" Then os.SetField RepField, "OFF"
	If AddVal = "" Then os.SetField AddField, "OFF"
	If AddUVal = "" Then os.SetField AddUField, "OFF"
	If RRVal = "" Then os.SetField RRField, "OFF"
	If DVal = "" Then os.SetField DField, "OFF"
	If TVal = "" Then os.SetField TField, "OFF"

	ci.Text = LCase(Ci.Text)

	RollAction = 0
	ActionCheck = Left(ci.Text, 2)
	If ActionCheck = " +" or ActionCheck = " -" Then RollAction = 1
	ActionCheck = Left(ci.Text, 5)
	If ActionCheck = " help" Then RollAction = 2

	If RollAction = 1 and pc.isGM = True Then
		Select Case ci.Text
		Case " +rep"
			RepVal = "ON"
			ci.Action = "edited the /roll Rep property"
			ci.Text = "Rep is now ON."
		Case " +add"
			AddVal = "ON"
			AddUVal = "OFF"
			RRVal = "OFF"
			ci.Action = "edited the /roll Add property"
			ci.Text = "Add is now ON."
		Case " +addu"
			AddUVal = "ON"
			AddVal = "OFF"
			RRVal = "OFF"
			ci.Action = "edited the /roll AddU property"
			ci.Text = "AddU is now ON."
		Case " +rr"
			RRVal = "ON"
			AddVal = "OFF"
			AddUVal = "OFF"
			ci.Action = "edited the /roll RR property"
			ci.Text = "RR is now ON."
		Case " +d"
			DVal = "ON"
			ci.Action = "edited the /roll D property"
			ci.Text = "D is now ON."
		Case " +t"
			TVal = "ON"
			ci.Action = "edited the /roll T property"
			ci.Text = "T is now ON."
		Case " -rep"
			RepVal = "OFF"
			ci.Action = "edited the /roll Rep property"
			ci.Text = "Rep is now OFF."
		Case " -add"
			AddVal = "OFF"
			ci.Action = "edited the /roll Add property"
			ci.Text = "Add is now OFF."
		Case " -addu"
			AddUVal = "OFF"
			ci.Action = "edited the /roll AddU property"
			ci.Text = "AddU is now OFF."
		Case " -rr"
			RRVal = "OFF"
			ci.Action = "edited the /roll RR property"
			ci.Text = "RR is now OFF."
		Case " -d"
			DVal = "OFF"
			ci.Action = "edited the /roll D property"
			ci.Text = "D is now OFF."
		Case " -t"
			TVal = "OFF"
			ci.Action = "edited the /roll T property"
			ci.Text = "T is now OFF."
		Case Else
			ci.Action = "attempted to edit a /roll property"
			ci.Text = "Invalid property."
		End Select
	ElseIf RollAction = 1 and pc.isGM = False Then
		ci.PlayerTo = ci.PlayerFrom
		ci.Action = "attempted to edit a /roll property"
		ci.Text = "Only the GM can edit /roll properties."


	ElseIf ci.Text = " report" Then
		ci.PlayerTo = ci.PlayerFrom
		ci.Action = "requested a property report from /roll"
		ci.Text = "<table border=0 cellpadding=4 cellspacing=0><tr><td><B>Rep</B></td><td>Roll Replacement</td><td>" + RepVal + "</td></tr><td><B>Add</B></td><td>Add Rerolls Once</td><td>" + AddVal + "</td></tr><td><B>AddU</B></td><td>Add Rerolls (No Limit)</td><td>" + AddUVal + "</td></tr><td><B>RR</B></td><td>Seperate Rerolls</td><td>" + RRVal + "</td></tr><td><B>D</B></td><td>Calculate Difficulty</td><td>" + DVal + "</td></tr><td><B>T</B></td><td>Total Rolls</td><td>" + TVal + "</td></tr></table>"

	ElseIf RollAction = 2 Then
		ci.PlayerTo = ci.PlayerFrom
		ci.Action = "requested help information for /roll"
		Select Case ci.Text
		Case " help"
			ci.Text = "<BR>Type <B>/roll help <I>topic</I></B> to get help on that topic."
			ci.Text = ci.Text + "<BR>"
			ci.Text = ci.Text + "<BR><B>Topics</B>"
			ci.Text = ci.Text + "<BR>About"
			ci.Text = ci.Text + "<BR>Commands"
			ci.Text = ci.Text + "<BR>Properties"
			ci.Text = ci.Text + "<BR>Contact"
			ci.Text = ci.Text + "<BR>"
		Case " help about"
			ci.Text = "<DD>Sober Panda's Roll Replacement is a replacement for the original /roll command that allows for manipulation of how roll results are displayed."
			ci.Text = ci.Text + "<BR>"
		Case " help commands"
			ci.Text = "<DD>All <B>/roll</b> commands can also be called with <B>/r</B>."
			ci.Text = ci.Text + "<DD><B>/roll <I>expr</I></B> : Rolls the dice expression <I>expr</I>."
			ci.Text = ci.Text + "<DD><B>/roll <I>expr diff</i></B> : Rolls the dice expression <I>expr</I> with the difficulty <I>diff</I>. Difficulty is written a /d#, such as /d1 or /d2."
			ci.Text = ci.Text + "<DD><B>/roll +<I>prop</I></B> : Enables the property <I>prop</I>."
			ci.Text = ci.Text + "<DD><B>/roll -<I>prop</I></B> : Disables the property <I>prop</I>."
			ci.Text = ci.Text + "<DD><B>/roll report</B> : Displays the current status of all properties."
			ci.Text = ci.Text + "<BR>"
		Case " help properties"
			ci.Text = "<DD><B>Rep</B> : The Rep property turns Roll Replacement on or off. When on, die results are displayed invidually, and any other properties that are set ON will be used. When off, the <B>/roll</B> command will function as normal."
			ci.Text = ci.Text + "<DD><B>Add</B> : The Add property turns rerolling on or off. When on, all die results that are equal to the highest possible result are rerolled and the new roll is added to the original."
			ci.Text = ci.Text + "<DD><B>AddU</B> : The Add property turns rerolling on or off. When on, all die results that are equal to the highest possible result are rerolled and the new roll is added to the original. As long as the sum of the rolls continues to be the highest possible result, it will continue to be rerolled."
			ci.Text = ci.Text + "<DD><B>RR</B> : The Add property turns rerolling on or off. When on, all die results that are equal to the highest possible result are rerolled as additional additional dice."
			ci.Text = ci.Text + "<DD><B>D</B> : The D property turns difficulty handling on or off. When on, all successful rolls (rolls equal to or greater than the difficulty) are displayed in bold."
			ci.Text = ci.Text + "<DD><B>T</B> : The T property turn totalling on or off. When on, a total of the die results is displayed in addition to the individual results."
			ci.Text = ci.Text + "<BR>"
		Case " help contact"
			ci.Text = "<DD>Send comments, suggestions, or bug reports to david@soberpanda.com."
			ci.Text = ci.Text + "<BR>"
		Case Else
			ci.Action = "requested help information for /roll"
			ci.Text = "Invalid help topic."
		End Select

	ElseIf RepVal = "OFF" and RollAction = 0 Then
		ci.Action = "rolls" + ci.Text
		ci.Text = EvalDice(ci.Text)

	ElseIf RepVal = "ON" and RollAction = 0 Then
		DInd = inStr(ci.Text, "d")
		PlusInd = inStr(ci.Text, "+")
		If PlusInd >< 0 Then
			ModInd = PlusInd
			ModType = "+"
		End If
		MinInd = inStr(ci.Text, "-")
		If MinInd >< 0 Then
			ModInd = MinInd
			ModType = "-"
		End If
		DifInd = inStr(ci.Text, "/d")

		MidLen = DInd - 1
		DiceNum = Mid(ci.Text, 1, MidLen)

		If ModInd >< 0 Then
			MidLen = ModInd - 1 - DInd
		ElseIf DifInd >< 0 Then
			MidLen = DifInd - 2 - DInd
		Else
			MidLen = Len(ci.Text) - DInd
		End If
		MidStart = Dind + 1
		SidesNum = Mid(ci.Text, MidStart, MidLen)

		If ModInd >< 0 Then
			If DifInd >< 0 Then
				MidLen = DifInd - 2 - ModInd
			Else
				MidLen = Len(ci.Text) - ModInd
			End If
			MidStart = ModInd + 1
			ModNum = Mid(ci.Text, MidStart, MidLen)
		Else
			ModNum = "0"
		End If

		If DifInd >< 0 Then
			MidLen = Len(ci.Text) - 1 - DifInd
			MidStart = DifInd + 2
			DifNum = Mid(ci.Text, MidStart, MidLen)
		Else
			DifNum = "0"
		End If

		Dice = CInt(DiceNum)
		Sides = CInt(SidesNum)
		Modifier = CInt(ModNum)
		If DifNum = "0" Then DifNum = SidesNum
		Difficulty = CInt(DifNum)
		If ModNum = "0"Then Expression = DiceNum + "D" + SidesNum
		If ModNum >< "0" Then Expression = DiceNum + "D" + SidesNum + ModType + ModNum
		If DVal = "ON" Then Expression = Expression + " with a difficulty of " + DifNum

		ci.Text = ""

		Do While Dice > 0
			ci.Text = ci.Text + " "
			RollNow = RollDice(1, Sides, 0)

			If AddVal = "ON" Then
				If RollNow = Sides Then
					RollNew = RollDice(1, Sides, 0)
					RollNow = RollNow + RollNew
				End If
			End If

			If AddUVal = "ON" Then
				AddTimes = 1
				BestRoll = AddTimes * Sides
				Do While RollNow = BestRoll
					If RollNow = BestRoll Then
						RollNew = RollDice(1, Sides, 0)
						RollNow = RollNow + RollNew
					End If
					AddTimes = AddTimes + 1
					BestRoll = AddTimes * Sides
				Loop
			End If

			If RRVal = "ON" Then
				If RollNow >< Sides Then Dice = Dice - 1
			Else
				Dice = Dice - 1
			End If

			If DVal = "ON" Then
				If RollNow >= Difficulty Then ci.Text = ci.Text + "<b>" + CStr(RollNow) + "</b>"
				If RollNow < Difficulty Then ci.Text = ci.Text + CStr(RollNow)
			Else
				ci.Text = ci.Text + CStr(RollNow)
			End If

			RollTotal = RollTotal + RollNow
		Loop

		If ModType = "+" Then RollTotal = RollTotal + Modifier
		If ModType = "-" Then RollTotal = RollTotal - Modifier

		ci.Action = "rolls " + Expression
		ci.Text = ci.Text

		If TVal = "ON" Then ci.Text = ci.Text + ", <B>Total:</B> " + CStr(RollTotal)

		If DInd = 0 Then
			ci.PlayerTo = ci.PlayerFrom
			ci.Action = "attempted to use the /roll command"
			ci.Text = "Invalid command."
		End If
	End If

	os.SetField "RepField", RepVal
	os.SetField "AddField", AddVal
	os.SetField "AddUField", AddUVal
	os.SetField "RRField", RRVal
	os.SetField "DField", DVal
	os.SetField "TField", TVal
End Sub